"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAction = function (type) {
    var creator = function (payload) { return ({ type: type, payload: payload }); };
    creator.matches = function (action) { return action.type === type; };
    creator.type = type;
    return creator;
};
exports.createApiAction = function (type, options) {
    var pendingType = type + "_PENDING";
    var successType = type + "_SUCCESS";
    var failureType = type + "_FAILURE";
    var creator = function (payload) {
        var _a = typeof (options) === 'function' ? options(payload) : options, CALL_API = _a.CALL_API, method = _a.method, endpoint = _a.endpoint, credentials = _a.credentials, headers = _a.headers;
        return _b = {},
            _b[CALL_API] = {
                endpoint: endpoint,
                method: method,
                types: [pendingType, successType, failureType],
                body: method === 'POST' || method === 'PUT' ? payload : undefined,
                credentials: credentials,
                headers: headers,
            },
            _b;
        var _b;
    };
    creator.type = type;
    creator.matchesPending =
        function (action) { return action.type === pendingType; };
    creator.matchesSuccessResponse =
        function (action) { return action.type === successType; };
    creator.matchesFailureResponse =
        function (action) { return action.type === failureType; };
    return creator;
};
